-- Gates

local Gates = {}
Gates.__index = Gates

Gates.speed = 200

function Gates.create()
	local inst = { numbers = { 2, 19, 6 }, y = 0, maxY = 0 }

	-- Question
	local a = math.random(2, 8)
	local b = math.random(2, 7)
	if a * b < 15 then
		inst.question = a .. ' x ' .. b
		inst.answer = a * b
	else
		inst.question = a .. ' + ' .. b
		inst.answer = a + b
	end
	inst.numbers = { math.random(2, 15), math.random(2, 15), math.random(2, 15) }
	inst.answerIndex = math.random(1, 3)
	for i=1, 3 do
		if inst.numbers[i] == inst.answer and i ~= inst.answerIndex then
			inst.numbers[i] = inst.numbers[i] - 1
		end
	end
	inst.numbers[inst.answerIndex] = inst.answer
	inst.answerPos = inst.answerIndex * width/3

	setmetatable(inst, Gates)
	return inst
end

function Gates:update(dt)
	self.y = self.y + self.speed * dt
end

function Gates:draw()
	local table = { '', '', '' }
	if self.hidden then
		table[self.sIndex] = self.numbers[self.sIndex]
		if self.sIndex == self.answerIndex then
			love.graphics.setColor(0, .7, 0)
		else love.graphics.setColor(.7, 0, 0) end
	else
		table = self.numbers
		love.graphics.setColor(0, 0, 0)
	end

	love.graphics.setFont(font)

	local frameWidth = 70
	for i,v in ipairs(table) do
		love.graphics.printf(v, (i-1)/3 * width, self.y, width / 3, 'center')
		love.graphics.setLineWidth(3)

		if v ~= '' then
			love.graphics.rectangle('line',
				(i*2 - 1)/6 * width - frameWidth/2,
				self.y - (frameWidth - font:getHeight())/2,
				frameWidth, frameWidth)
		end
	end
	love.graphics.printf(self.question, 0, self.y + 80, width, 'center')
	self.maxY = self.y - (frameWidth - font:getHeight())/2 + frameWidth
end

return Gates
