-- Mathot game

local mathot = { scale = 4 }
local poss
local Gates

local gatess = {}
local record = 1

local scrollDistance
local gameState = 'game'

function love.load()
	math.randomseed(os.time())
	-- Dimensions
	width = love.graphics.getWidth()
	height = love.graphics.getHeight()
	scrollDistance = height * 4/5
	
	-- Module
	Gates = require 'gates'
	table.insert(gatess, Gates.create())

	-- Player
	love.graphics.setDefaultFilter('nearest', 'nearest')
	mathot.image = love.graphics.newImage('mathot.png')
	mathot.width = mathot.image:getWidth() * mathot.scale
	mathot.life = 5
	mathot.score = 0
	mathot.combo = 0

	poss = {
		width/6 - mathot.width/2, width/2 - mathot.width/2,
		width * 5/6 - mathot.width/2
	}

	mathot.pos = 2

	-- Graphics
	font = love.graphics.newFont(30)
	iconsFont = love.graphics.newFont('icons.ttf', 30)
	love.graphics.setBackgroundColor(1, 1, 1)
end

function love.update(dt)
	if gameState == 'game' then
		local add1 = false
		-- Gates
		for i=1, #gatess do
			local g = gatess[i]
			g:update(dt)
			if g.maxY > height * 2/3 then
				if not g.hidden then
					if math.abs(poss[mathot.pos] + mathot.width/1 - g.answerPos)
						< width/6 then
						mathot.score = mathot.score + 1
						mathot.combo = mathot.combo + 1
						if mathot.combo == 3 then 
							Gates.speed = Gates.speed * 1.15
							mathot.combo = 0
						end
					else
						mathot.life = mathot.life - 1
						Gates.speed = Gates.speed * .85
						mathot.combo = 0
					end
					if mathot.life == 0 then gameState = '' end
					g.sIndex = mathot.pos
					g.hidden = true
				end
			end
			if g.maxY > scrollDistance and not g.counted then
				add1 = true
				g.counted = true
			end
		end
		if add1 then table.insert(gatess, Gates.create()) end

		-- Mathot
		if mathot.combo % 8 == 0 and mathot.combo ~= 0 then
			mathot.life = math.min(5, mathot.life + 1)
		end

		-- Controls
		local xGoal
		if love.mouse.isDown(1) then xGoal, _ = love.mouse.getPosition()
		elseif love.touch.getTouches()[1] then
			xGoal, _ = (love.touch.getTouches())[1].getPosition() end
		if xGoal then
			if xGoal < width / 3 then mathot.pos = 1
			elseif xGoal < width * 2/3 then mathot.pos = 2
			else mathot.pos = 3 end
		end
	end
end

function love.keypressed(key)
	if key == 'right' then mathot.pos = math.min(mathot.pos + 1, 3)
	elseif key == 'left' then mathot.pos = math.max(mathot.pos - 1, 1)
	end
end

function love.draw()
	if gameState == 'game' then
		local offset = 20

		love.graphics.setColor(0, 0, 0)
		for i=1,#gatess do gatess[i]:draw(mathot.pos) end
		love.graphics.setColor(1, 1, 1)
		love.graphics.rectangle('fill', 0, 0, width, 2*offset + font:getHeight())
		love.graphics.draw(mathot.image, poss[mathot.pos], height * 2/3, 0,
			mathot.scale)

		-- Texts
		love.graphics.setFont(font)

		love.graphics.setColor(0, .4, .5)
		love.graphics.printf(mathot.score, 0, offset, width, 'center')

		love.graphics.setColor(0, 0, 0)
		love.graphics.print(record, 30 + iconsFont:getWidth(record), offset)

		love.graphics.setFont(iconsFont)
		love.graphics.print(mathot.life,
			width - offset - iconsFont:getWidth(mathot.life), offset)
		love.graphics.print('t', offset, offset)
	else
		love.graphics.setFont(font)
		love.graphics.setColor(0, 0, 0)
		love.graphics.printf('Perdu :(', 0, height/2 - font:getHeight(), width,
			'center')
		love.graphics.setColor(0, .4, .5)
		love.graphics.printf(mathot.score, 0, height/2 + 120, width, 'center')
	end
end
